unit Crash;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, RXCtrls, Animate, GIFCtrl, ExtCtrls, ExceptEx;

type TTypeCrash=(tcOrdinary, tcGlobal);

type
  TfmCrash = class(TForm)
    RxGIFAnimator1: TRxGIFAnimator;
    RxLabel1: TRxLabel;
    lbMsg: TRxLabel;
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    Bevel1: TBevel;
    Label1: TLabel;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShowCrash(msg:string;TypeCrash:TTypeCrash=tcOrdinary);
procedure HandleQRAccessViolation(E: Exception);
procedure HandleDefaultException(E: Exception);

implementation

uses StrUtils, QueryEx, AppInfo, {mdMailSlot, }SendMsg, dmdURep;


{$R *.DFM}


procedure ShowCrash(msg:string;TypeCrash:TTypeCrash=tcOrdinary);
begin
   with TfmCrash.Create(nil) do
   begin
    lbMsg.Caption:=msg;
    ShowModal;
    Release;
   end;
end;

procedure defSaveException(const ExceptionClassName, ExceptionMessage: String);
var msg:string;
begin
  msg:=StringReplace(StringReplace(ExceptionMessage,#39,'^',[rfReplaceAll]),'"','^',[rfReplaceAll]);
  try
    DoSQLBDEOnly('exec spSaveException '#39+GetProgName+#39', '#39+ExceptionClassName+#39', '#39+msg+#39);
  except on e:Exception do
    begin
      SendAdminAlert(msg);
      msg:=e.Message;
      SendAdminAlert(msg);
    end;
  end;
end;

procedure HandleQRAccessViolation(E: Exception);
//var qrp:TComponent;
begin
//  SendAdminAlert('Error in QuickReport+TK detected and processed','gleb');
  SaveException(E.ClassName, 'Processed error in QR+TK: '#10#39+E.Message);
{  qrp:=Application.FindComponent('QRRussianPreview');
  try FreeAndNil(qrp) except end;
  qrp:=dmURep.FindComponent('ReportPrintForm');
  try FreeAndNil(qrp) except end;
  qrp:=dmURep.FindComponent('ReportDesignerForm');
  try FreeAndNil(qrp) except end;}
end;

procedure HandleDefaultException(E: Exception);
begin
  ShowCrash(E.Message);
  SaveException(E.ClassName, E.Message);
end;

procedure TfmCrash.BitBtn1Click(Sender: TObject);
begin
   Close;
end;

initialization
   SetTSaveExceptionFunc(defSaveException);

end.
