unit DBenv;

interface

//function GetCourse(Data:TDateTime):Currency;
procedure UndoOperation(idhistory:integer; IsMultiple:boolean=false);
function GetParametrVal(const ParamName: string) : string;
function GetServerName:string;
function GetDatabaseName:string;
function GetPassword:string;
//function GetADOConnString(const user:WideString=''; const pass:WideString=''): WideString;
//function IsADOImplement:boolean;
//function WithoutSQLError(txt:string):string;


implementation

uses Common, SysUtils, AppInfo, QueryEx, Forms, dbgrids,
     dbtables; //gvMconn, ADODB,

var Fserver, Fdatabase:string;

{
function IsADOImplement:boolean;
begin
  result:=(GetDBObject is TADOConnection);
end;
}

function GetServerName:string;
var v:variant;
begin
  if Fserver='' then
  begin
     v:=dlookup('select @@SERVERNAME');
     {
     if v=NULL then Fserver:=dmMain.dbTerbo.Params.Values['SERVER NAME']
               else Fserver:=v;
     }
     if v=NULL then Fserver:=TDatabase(GetDBObject).Params.Values['SERVER NAME']
     else Fserver:=v;

  end;
  result:=Fserver;
end;

function GetDatabaseName:string;
begin
  if Fdatabase='' then Fdatabase:=dlookup('select DB_NAME()');
  result:=Fdatabase;
end;

procedure UndoOperation(idhistory:integer; IsMultiple:boolean=false);
begin
  if (not IsMultiple)
      or Confirmation('    '#10#13
                     +'     '#10#13'?')
    then DoSQL('exec spHLUndo '+IntToStr(IdHistory));
end;

function GetParametrVal(const ParamName: string) : string;
begin
  result:= '';
  try
    result:=DLookup('declare @sss varchar(255)'#10#13
                     +'exec spGetParameter '''+ParamName+''',@sss output'#10#13
                     +'select @sss');
  except
    result:= '';
  end;
end;

{function GetCourse(Data:TDateTime):Currency;
begin
  try result:=DLookUp('declare @course money'#10#13
       +'exec spGetCourse '+DateForQuery(Data)+',2,@course output'#10#13
       +'select @course');
  except result:=0; end;
end;}

function GetPassword:string;
begin
  //if IsADOImplement
   //then result:=TMainConnection(GetDBObject).Params.Values['Password']
   //else
 result:=TDatabase(GetDBObject).Params.Values['PASSWORD'];
end;

{function GetADOConnString(const user:WideString=''; const pass:WideString=''): WideString;
var u,p,d,s:WideString;
begin
  if IsADOImplement then
    begin
      if (user<>'') or (pass<>'') then raise Exception.Create('GetADOConnString: Other user is'#10#13'not supported for TADOConnection');
      result:=TADOConnection(GetDBObject).ConnectionString;
    end
  else
    begin
      if user<>'' then
        begin
         u:=user;
         if p=''
           then p:=TDatabase(GetDBObject).Params.Values['PASSWORD']
           else p:=pass;
         d:=GetDatabaseName;
         s:=GetServerName;
        end
      else
        begin
          u:=TDatabase(GetDBObject).Params.Values['USER NAME'];
          p:=TDatabase(GetDBObject).Params.Values['PASSWORD'];
          d:=TDatabase(GetDBObject).Params.Values['DATABASE NAME'];
          s:=TDatabase(GetDBObject).Params.Values['SERVER NAME'];
        end;
      if pass='' then p:=GetPassword else p:=pass;
      result:='Provider=SQLOLEDB.1;Password='
              +p+';Persist Security Info=True;User ID='
              +u+';Initial Catalog='
              +d+';Data Source='
              +s+';Application Name='
              +GetProgName+';Workstation ID='
              +GetCompName+';';
    end;
end;
}
{procedure SQLErrorMsg(txt:string);
begin
	MessageDlg(WithoutSQLError(txt),mtError,[mbAbort],0);
end;

function WithoutSQLError(txt:string):string;
var
 localtxt:string;
 posMsg:integer;
begin
   localtxt:='General SQL error';
   posMsg:=Pos(localtxt,txt);
   if posMsg=0
     then localtxt:=txt
     else localtxt:=Copy(txt,posMsg+20,length(txt)-posMsg-19);
	result:=localtxt;
end;}


end.
