unit ExceptEx;

interface

procedure SaveException(const ExceptionClassName, ExceptionMessage: String);

type TSaveExceptionFunc = procedure(const ExceptionClassName, ExceptionMessage: String);

function GetTSaveExceptionFunc : TSaveExceptionFunc;
procedure SetTSaveExceptionFunc(pSaveExceptionFunc : TSaveExceptionFunc);

implementation


var glSaveExceptionFunc : TSaveExceptionFunc;

procedure SaveException(const ExceptionClassName, ExceptionMessage: String);
begin
  try
    if assigned(glSaveExceptionFunc) then
      glSaveExceptionFunc(ExceptionClassName, ExceptionMessage);
  except
  end;
end;

function GetTSaveExceptionFunc : TSaveExceptionFunc;
begin
  result := glSaveExceptionFunc;
end;

procedure SetTSaveExceptionFunc(pSaveExceptionFunc : TSaveExceptionFunc);
begin
  glSaveExceptionFunc := pSaveExceptionFunc;
end;



end.
