unit LayoutEx;

interface

uses SysUtils, controls;

procedure FitControlWidthToParent(Control:TControl);
procedure FitControlWidthToRControl(Control, RControl:TControl);
procedure FitControlLeftToParent(Control:TControl);
procedure FitControlLeftToRControl(Control, RControl:TControl);

implementation


procedure FitControlWidthToParent(Control:TControl);
begin
  Control.Width := Control.Parent.Width - Control.Left - 10;
end;

procedure FitControlWidthToRControl(Control, RControl:TControl);
begin
  Control.Width := RControl.Left - Control.Left - 10;
end;

procedure FitControlLeftToParent(Control:TControl);
begin
  Control.Left := Control.Parent.Width - Control.Width - 10;
end;

procedure FitControlLeftToRControl(Control, RControl:TControl);
begin
  Control.Left := RControl.Left - Control.Width - 10;
end;

end.
