unit NWsend;

interface

uses calwin32, NETWIN32, dialogs, sysutils;

{type
  nint8=shortint;
  nuint8=byte;
  nint16=smallint;
  nuint16=word;
  nint32=longint;
  nuint32=Longword;
  nint=longint;
  nuint=Longword;  }

type
//  NWCONN_HANDLE=nuint
//  NWCCODE=nuint
  NWNUMBER=nuint16;
  NWOBJ_ID=nuint32;
  NWFLAGS=nuint8;

procedure NovellSendMessage(const user, msg:string);

implementation

uses Common;

function NWCCScanConnRefs(var scanIterator:nuint32; out connRef:nuint32)
            :integer; stdcall; external 'clxwin32.dll' name 'NWCCScanConnRefs';

function NWCCOpenConnByRef(connRef:nuint32; openState, reserved:nuint; out ConnHandle:NWCONN_HANDLE)
            :integer; stdcall; external 'clxwin32.dll' name 'NWCCOpenConnByRef';



procedure NovellSendMessage(const user, msg:string);
var  {ccode: NWCCODE;}
     conn: NWCONN_HANDLE;
     maxConns: NWNUMBER;
     userID, ID: NWOBJ_ID;
     flag: NWFLAGS;
     i,connect_num:integer;
     connRef:nuint32;
     scanIterator:nuint32;
     err:integer;
label IS_USER_FOUND;
begin
  if NWCallsInit(nil,nil)<>0 then raise Exception.Create('Error - NWCallsInit');
{    Function NWGetConnectionHandle (
        pServerName  :   pnuint8 ;
        reserved1  :   nuint16 ;
        Var pConnHandle  : NWCONN_HANDLE;
        reserved2  :   pnuint16
    ) : NWCCODE;}
//  if NWGetConnectionHandle(nil{pointer(pchar(server))}, 0, conn, nil)<>0
//    then raise Exception.Create('Error - NWGetConnectionHandle');

  scanIterator:=0;
  err:=NWCCScanConnRefs(scanIterator, connRef);
  if err<>0 then raise Exception.Create('Error - NWCCScanConnRefs. Code:'+IntToStr(err));

  err:=NWCCOpenConnByRef(connRef,1,0,conn);
  if err<>0 then raise Exception.Create('Error - NWCCOpenConnByRef. Code:'+IntToStr(err));

  err:=NWGetObjectID(conn, pointer(pchar(user)), OT_USER, @userID);
  if err<>0 then raise Exception.Create('Error - NWGetObjectID. Code:'+IntToStr(err));

  err:=NWGetFileServerInformation(conn,nil,nil,nil,nil,@maxConns,nil,nil,nil,nil,nil);
  if err<>0 then raise Exception.Create('Error - NWGetFileServerInformation. Code:'+IntToStr(err));

  for i:=0 to maxConns-1 do
  begin
    NWGetConnectionInformation(conn, i, nil, nil, @ID, nil);
    if ID=userID then
    begin
      connect_num:=i;
      goto IS_USER_FOUND;
    end;
  end;
  raise Exception.Create('Error - User not found');

IS_USER_FOUND:
  err:=NWSendBroadcastMessage(conn, pointer(pchar(WinToDos(msg))),1,@connect_num,@flag);
  if err<>0 then raise Exception.Create('Error - NWSendBroadcastMessage. Code:'+IntToStr(err));
  if flag>0 then raise Exception.Create('Error - Server return code:'+IntToStr(flag));
end;


end.
