unit RBenv;

interface

procedure ReportOut(SQLstr,ReportName:string;PTranslate:Pointer=nil);
// ReportName   '.', ,   Excel

implementation

uses Common, QueryEx, AppInfo, ExcelEx,
     SysUtils, Forms, Db, DBTables, Dialogs,
     ppEndUsr,  ppReport,  ppDBBDE,  ppTypes;

type TTranslate=procedure (DataSet:TDataSet);

procedure ReportOut(SQLstr,ReportName:string;PTranslate:Pointer=nil);
var q:TDataSet;
    Designer:TppDesigner;
    ToExcel:boolean;
begin
  ToExcel:=(pos('.',ReportName)=0);
  q:=GetPlatformDataSet(SQLstr);
  try
    if ToExcel then q.Name:=ReportName
    else
      begin
        Designer:=TppDesigner.Create(nil);
        with Designer do
        try
          Report:=TppReport.Create(Designer);
          with Report do
          begin
            DataPipeline:=TppBDEPipeline.Create(Designer);
            with TppBDEPipeline(DataPipeline) do
            begin
              DataSource:=TDataSource.Create(Designer);
              DataSource.DataSet:=q;
              DataPipeline.Name:='Pipeline';
              PrinterSetup.PaperName:= 'A4';
              Units:=utMillimeters;
              WindowState:=wsMaximized;
              Template.FileName:=ExtractFilePath(GetShortPath)+ReportName;
              Template.LoadFromFile;
              ShowPrintDialog:=true;//not DirectPrinter;
{              if DirectPrinter then
                begin
                  Device:=dvPrinter;
                  Print;
                end
              else
                begin }
                  Device:=dvScreen;
                  Notebook.SelectNextPage(true);
                  ShowModal;
//                end;
            end;
          end;
        finally
          Designer.Free;
        end;
      end;
    if ToExcel then
    begin
      if PTranslate<>nil then TTranslate(PTranslate)(q);
      DataSetToExcel(q);
    end;
  finally
   q.Free;
  end;
end;

end.
