unit RecInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, dbgrids;

procedure ShowRecorgInfo;

type
  TfmRecordInfo = class(TForm)
    lbInfo: TLabel;
    procedure FormDeactivate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbInfoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  public
    constructor CreateInfo(const Table:String; const Id:integer);
  end;

implementation

{$R *.DFM}

uses Common, Consol, QueryEx;

procedure ShowRecorgInfo;
var DataSet:TDataSet; Id:integer;
begin
  DataSet:=GetGeneralDataSet;
  if (DataSet=nil) or (DataSet.FindField('Id')=nil) then Exit;
  Id:=DataSet.FieldByName('Id').AsInteger;
  TfmRecordInfo.CreateInfo(GetTableName(DataSet, Id),Id);
end;

constructor TfmRecordInfo.CreateInfo(const Table:String; const Id:integer);
var v:Variant;  lb:string;
begin
  if Table>'' then
    begin
      v:=DLookupArray('exec spGetRecordInfo2 '+Table+','+IntToStr(Id));
      lb:=VarToStr(v[3]);
      DefaultSQL:='select * from '+VarToStr(v[2])+' where Id='+IntToStr(Id);
    end
  else
    lb:='Id='+IntToStr(Id);
  inherited Create(Screen.ActiveForm);
  lbInfo.Caption:=lb;
  Height:=lbInfo.Height+10;
  Width:=lbInfo.Width+10;
  self.Show;
end;

procedure TfmRecordInfo.FormDeactivate(Sender: TObject);
begin
  Close;
end;

procedure TfmRecordInfo.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Close;
end;

procedure TfmRecordInfo.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Close;
end;

procedure TfmRecordInfo.lbInfoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Close;
end;

end.
