unit Slot;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mdMailSlot, VCLUtils, RXShell, AppUtils, ConstEx;

type
  TfmSlot = class(TForm)
    MailSlot: TmdMailSlot;
    procedure MailSlotMessageAvail(Sender: TObject; Msg: String);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    OldSlotMsg:string;
    OldTick:dword;
    procedure OnHideMsg(var Message:TMessage); message WM_SLOTFORM_HIDE;
//    function ExecCommand(cmd:string):string;
  end;

procedure  MailSlotCreate;

implementation

{$R *.DFM}

uses Common, AppInfo;

procedure  MailSlotCreate;
begin TfmSlot.Create(Forms.Application.MainForm); end;

procedure TfmSlot.OnHideMsg(var Message:TMessage);
begin
  Hide;
end;

procedure TfmSlot.MailSlotMessageAvail(Sender: TObject; Msg: String);
var
  freq, i, j, ipos : integer;
  ch : boolean;
  starttick : uint;
  sCmd : string;
//  aFrm: TForm;
begin
  if (OldSlotMsg<>Msg) or
     ((OldSlotMsg=Msg) and ((GetTickCount-OldTick)>10000)) then
  begin
    ipos := Pos(SYS_COMMAND_PREFIX, Msg);
    if ipos>0 then
      begin
      ipos := ipos+length(SYS_COMMAND_PREFIX);
      sCmd := Trim(Copy(Msg, ipos, length(Msg)-ipos+1));
      if sCmd=SYSCMD_REFRESHUREPMAIN then
        begin
        //aFrm := FindForm(TfrmURepMain);
        //if aFrm<>nil then
        //  (aFrm as TfrmURepMain).RefreshTree(True);
           GoMessage(WM_UREPTBLCHANGE);
        end;

      //SendToMailSlot('odissey',ExeFileName,RES_COMMAND_ATTR+' '+ExecCommand(copy(Msg,spos+Length(SYS_COMMAND_ATTR)+1,Length(Msg)-spos-Length(SYS_COMMAND_ATTR))));
      end
     else
      begin

        ch:=true;
        i:=0;
        //sleep(3000);
        starttick:=GetTickCount;
        repeat
          if ch then freq:=1000 else freq:=2000;
          ch:=not ch;
          gvbeep(freq,80);
          inc(i);
          sleep(0);
          Application.ProcessMessages;
          if i>10 then
          begin
            i:=0;
            for j:=0 to 300 do
            begin
             sleep(10);
             Application.ProcessMessages;
             if Application.Terminated or Application.Active  or ((GetTickCount-starttick)>20000) then break;
            end;
          end;
        until Application.Active or Application.Terminated or ((GetTickCount-starttick)>20000);
        with CreateMessageDialog(Msg,mtCustom,[mbOK]) do
        begin
          ShowModal;
          Release;
          Free;
        end;
      end;
  end;
  OldSlotMsg:=Msg;
  OldTick:=GetTickCount;
end;

{function TfmSlot.ExecCommand(cmd:string):string;
begin
   if WinExec(PChar(cmd),SW_HIDE)>31
    then result:='Good Start'
    else result:='Bad Start';
end; }

procedure TfmSlot.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfmSlot.FormCreate(Sender: TObject);
begin
  PostMessage(Handle,WM_SLOTFORM_HIDE,0,0);
  Height:=0;
  Width:=0;
  OldSlotMsg:='';
  OldTick:=0;
  MailSlot.Slot:=GetProgName;
  MailSlot.Open;
end;

procedure TfmSlot.FormDestroy(Sender: TObject);
begin
   MailSlot.Close;
end;

end.
