unit WordNumber;

interface

uses SysUtils, Classes, Math;

// IntNames: "0-name", "1-name", "2-name"
//   .: "", "", ""

// FracNames: "0-name", "1-name", "2-name"
//   .: "", "", ""

Function FullWord_Number(currSumm : Extended; isMoney: Boolean;
                         FracAccuracy: integer;
                         IntNames : TStrings;
                         FracNames : TStrings) : String;

Function Word_Number(currSumm : Extended; isMoney: Boolean) : String;

function NumToText(CurrValue:Currency; CurrWord:boolean; IfKopeck:boolean):string;
function DollarString(CurrValue:Currency):string;

implementation

uses StrUtils;

Function Asc(ss: string) : integer;
begin
  Asc := Ord(ss[1]);
end;

function ReplicateChr( Ch : Char; Cnt : integer ) : string;
var
   sss : string;
   i : Integer;
begin
   sss := '';
   for i := 1 to Cnt do
      sss := sss + Ch;
   Result := sss;
end;

Function type_rem(SSprev : String; ss :  String) : Integer;
var
  f : Integer;
begin
//gleb  type_rem := 0;
  f := Asc(Copy(ss, 1, 1)) - Asc('0');

  If (SSprev = '1') Then
    type_rem := 2
  Else If f = 1 Then
    type_rem := 0
  Else If (f > 1) And (f < 5) Then
    type_rem := 1
  Else
    type_rem := 2;
End;


Function FullWord_Number(currSumm : Extended; isMoney: Boolean;
                         FracAccuracy: integer;
                         IntNames : TStrings;
                         FracNames : TStrings) : String;
var
  Frac, idxIntNames, idxFracNames : integer;
  SumS, ssFrac : String;
  i, iis, ig, j : Integer;
  Type11, isNull, llen, FracBase : Integer;
  ss, SSnext, SSprev : String;
  SumW {, P gleb}: String;
const
  A : array [0..3, 1..9] of string =
  ( ('', '', '', '', '',
     '','', '',  ''),
    ('', '', '', '', '',
     '', '', '', ''),
    ('', '', '', '', '',
     '', '', '', ''),
    ('', '', '', '', '',
     '', '', '', '') );

 Osn : array [0..5] of string =
    ('', '', '', '', '', '');

 Dop: array [0..1, 0..2] of string = //(2, 3) As String
 (('', '', ''),
  ('', '', ''));
begin
idxIntNames:=0; idxFracNames :=0;
SumS := IntToStr(Trunc(currSumm)) ;

//gleb iis := 0; //   
//gleb ig := 0; //   (   )
isNull := 0; // ,       = 0
Type11 := 0;

SumS := Trim(SumS);
While (Length(SumS)>0) and (SumS[1] = '0') do
  SumS := Copy(SumS, 2, length(SumS));

llen := Length(SumS);
If  llen = 0 Then
  begin
  SumW := '';
  end
else
  begin
  SumW := '';
  j := 1;
  For i := llen DownTo 1 do
    begin
    ig := i div 3;
    iis := i - (ig * 3);
    If iis = 0 Then
      iis := 3;
    If iis = 3 Then
      ig := ig - 1;
    ss := Copy(SumS, j, 1);
    If j < llen Then
      SSnext := Copy(SumS, j + 1, 1)
    Else
      SSnext := '';
    If j > 1 Then
      SSprev := Copy(SumS, j - 1, 1)
    Else
      SSprev := '';

    If (iis = 2) And (ss = '1') And (SSnext > '0') Then //And  *(SS+1) > '0')
      Type11 := 1
    Else
      begin
      If Asc(ss) > Asc('0') Then
        begin
        If Type11 = 1 Then   // 11, 12, 13, 14, 15, 16, 17, 18, 19
          SumW := SumW + A[0, Asc(ss) - Asc('0')]
        Else   // else (1)
          begin
          If (ig=1) And (iis=1) And (ss='1') Then
            SumW := SumW + ''
          Else If (ig=1) And (iis=1) And (ss='2') Then
            SumW := SumW + ''
          Else If (isMoney=False) And (ig=0) And (iis=1) And (ss='1') Then // 
            SumW := SumW + ''
          Else If (isMoney=False) And (ig=0) And (iis=1) And (ss='2') Then  // 
            SumW := SumW + ''
          Else
            SumW := SumW + A[iis, Asc(ss) - Asc('0')];
          end;
        Type11 := 0;
        SumW := SumW + ' ';
        isNull := isNull + 1;

        If (ig=0) And (iis=1) And (ss='1') Then
          idxIntNames := 1
        Else If (ig=0) And (iis=1) And (ss[1] in ['2','3','4']) Then
          idxIntNames := 2;
        end
      Else
        If (iis = 3) Then isNull := 0;
    end;

    If (ig > 0) And (iis = 1) And (isNull<>0) Then
      begin
      SumW := SumW + Osn[ig - 1];
      If (ig = 1) Then
        SumW := SumW + Dop[0, type_rem(SSprev, ss)]
      Else
        SumW := SumW + Dop[1, type_rem(SSprev, ss)];
      SumW := SumW + ' ';
      end;

    j := j + 1;
    end;
  end;

if IntNames<>nil then
  begin
  if idxIntNames>(IntNames.Count-1) then
    idxIntNames := IntNames.Count-1;
  if idxIntNames>=0 then
    SumW := SumW + ' ' + IntNames[idxIntNames];
  end;
if FracNames<>nil then
  begin
  FracBase := Round(IntPower(10, FracAccuracy));
  Frac := (Round(currSumm*FracBase)) mod FracBase;
  ssFrac := FormatFloat(ReplicateChr('0', FracAccuracy), Frac);

  if (ssFrac[FracAccuracy]='1') and
     (not(FracAccuracy>1) or
         ((FracAccuracy>1) and (ssFrac[FracAccuracy-1]<>'1'))) then
    idxFracNames := 1
  Else
    If (ssFrac[FracAccuracy] in ['2','3','4']) and
       (not(FracAccuracy>1) or
           ((FracAccuracy>1) and (ssFrac[FracAccuracy-1]<>'1'))) then
      idxFracNames := 2;

  if idxFracNames>(FracNames.Count-1) then
    idxFracNames := FracNames.Count-1;
  if idxFracNames>=0 then
    SumW := SumW +  ' ' + ssFrac + ' ' + FracNames[idxFracNames];
  end;
FullWord_Number := SumW;
end;

Function Word_Number(currSumm : Extended; isMoney: Boolean) : String;
begin
  Word_Number := FullWord_Number(currSumm, isMoney, 2, nil, nil);
end;


{Function Word_Number(currSumm : Currency; isMoney: Boolean) : String;
var
  SumS : String;
  i, iis, ig, j : Integer;
  Type11, isNull, llen : Integer;
  ss, SSnext, SSprev : String;
  SumW , P : String;
const
  A : array [0..3, 1..9] of string =
  ( ('', '', '', '', '',
     '','', '',  ''),
    ('', '', '', '', '',
     '', '', '', ''),
    ('', '', '', '', '',
     '', '', '', ''),
    ('', '', '', '', '',
     '', '', '', '') );

 Osn : array [0..5] of string =
    ('', '', '', '', '', '');

 Dop: array [0..1, 0..2] of string = //(2, 3) As String
 (('', '', ''),
  ('', '', ''));
begin

SumS := IntToStr(Round(currSumm)) ;

iis := 0; //   
ig := 0; //   (   )
isNull := 0; // ,       = 0
Type11 := 0;

SumS := Trim(SumS);
While (Length(SumS)>0) and (SumS[1] = '0') do
  SumS := Copy(SumS, 2, length(SumS));

llen := Length(SumS);
If  llen = 0 Then
  begin
  Word_number := '';
  Exit;
  end;

SumW := '';
j := 1;
For i := llen DownTo 1 do
  begin
  ig := i div 3;
  iis := i - (ig * 3);
  If iis = 0 Then
    iis := 3;
  If iis = 3 Then
    ig := ig - 1;
  ss := Copy(SumS, j, 1);
  If j < llen Then
    SSnext := Copy(SumS, j + 1, 1)
  Else
    SSnext := '';
  If j > 1 Then
    SSprev := Copy(SumS, j - 1, 1)
  Else
    SSprev := '';

  If (iis = 2) And (ss = '1') And (SSnext > '0') Then //And  *(SS+1) > '0')
    Type11 := 1
  Else
    begin
    If Asc(ss) > Asc('0') Then
      begin
      If Type11 = 1 Then   // 11, 12, 13, 14, 15, 16, 17, 18, 19
        SumW := SumW + A[0, Asc(ss) - Asc('0')]
      Else   // else (1)
        begin
        If (ig=1) And (iis=1) And (ss='1') Then
          SumW := SumW + ''
        Else If (ig=1) And (iis=1) And (ss='2') Then
          SumW := SumW + ''
        Else If (isMoney=False) And (ig=0) And (iis=1) And (ss='1') Then // 
          SumW := SumW + ''
        Else If (isMoney=False) And (ig=0) And (iis=1) And (ss='2') Then  // 
          SumW := SumW + ''
        Else
          SumW := SumW + A[iis, Asc(ss) - Asc('0')];
        end;
      Type11 := 0;
      SumW := SumW + ' ';
      isNull := isNull + 1;
      end
    Else
      If (iis = 3) Then isNull := 0;
  end;

  If (ig > 0) And (iis = 1) And (isNull<>0) Then
    begin
    SumW := SumW + Osn[ig - 1];
    If (ig = 1) Then
      SumW := SumW + Dop[0, type_rem(SSprev, ss)]
    Else
      SumW := SumW + Dop[1, type_rem(SSprev, ss)];
    SumW := SumW + ' ';
    end;

  j := j + 1;
  end;

Word_number := SumW;
End; }


function NumToText(CurrValue:Currency; CurrWord:boolean; IfKopeck:boolean):string;

  function GetNumInPos(CurrValue:Currency; PosNum: Integer):Integer;
  var
      tmpstr,tmpint,tmpfrac:string;
      pospoint:integer;
  begin
      Result:=0;
      tmpstr:=CurrToStr(CurrValue);
      pospoint:=Pos('.',tmpstr);
      if PosNum>0 then
        begin
          if pospoint>0
           then tmpint:=Copy(tmpstr,1,pospoint-1)
           else tmpint:=tmpstr;
          if PosNum>Length(tmpint) then exit;
          Result:=StrToInt(Copy(tmpint,Length(tmpint)-PosNum+1,1));
        end;
      if PosNum<0 then
        begin
          if pospoint>0
           then tmpfrac:=Copy(tmpstr,pospoint+1,Length(tmpstr)-pospoint)
           else tmpfrac:='00';
          if Length(tmpfrac)<(-PosNum) then exit;
          Result:=StrToInt(Copy(tmpfrac,-PosNum,1));
        end;
  end;

  function GetKopeck(CurrValue:Currency):string;
  var
    Dig1,Dig2,Val:Integer;
    KWord:string;
  begin
    Dig1:=GetNumInPos(CurrValue,-1);
    Dig2:=GetNumInPos(CurrValue,-2);
    Val:=Round(Frac(CurrValue)*100);
    if (Val>10) or (Val<20) then Dig2:=Val;
    case Dig2 of
      0,5..9,11..19:KWord:='';
      1:KWord:='';
      2..4:KWord:='';
    end;
    Result:=' '+IntToStr(Dig1)+IntToStr(Dig2)+' '+KWord;
  end;

  function GetOneVal(CurrValue:Currency;CathNum:Integer):integer;
  begin
    Result:=StrToInt(IntToStr(GetNumInPos(CurrValue,CathNum*3))
                    +IntToStr(GetNumInPos(CurrValue,CathNum*3-1))
                    +IntToStr(GetNumInPos(CurrValue,CathNum*3-2)));
    Result:=Result-1+1;
  end;

  function OneCathegory(OneVal,CathNum:Integer):string;

    function Cath000(Val000:Integer):string;
    begin
       result:='';
       case Val000 of
        1: result:=' ';
        2: result:=' ';
        3: result:=' ';
        4: result:=' ';
        5: result:=' ';
        6: result:=' ';
        7: result:=' ';
        8: result:=' ';
        9: result:=' ';
       end;
    end;

    function Cath_00(Val_00:Integer):string;
    begin
       result:='';
       case Val_00 of
        1: result:=' ';
        2: result:=' ';
        3: result:=' ';
        4: result:=' ';
        5: result:=' ';
        6: result:=' ';
        7: result:=' ';
        8: result:=' ';
        9: result:=' ';
       end;
    end;

    function Cath__0(Val__0:Integer; IfThousand:boolean):string;
    begin
       result:='';
       case Val__0 of
          1: if IfThousand then result:=' ' else result:=' ';
          2: if IfThousand then result:=' ' else result:=' ';
          3: result:=' ';
          4: result:=' ';
          5: result:=' ';
          6: result:=' ';
          7: result:=' ';
          8: result:=' ';
          9: result:=' ';
       end;
    end;

    function Cath_11(Val_11:Integer):string;
    begin
       result:='';
       case Val_11 of
          11: result:=' ';
          12: result:=' ';
          13: result:=' ';
          14: result:=' ';
          15: result:=' ';
          16: result:=' ';
          17: result:=' ';
          18: result:=' ';
          19: result:=' ';
       end;
    end;

  begin
    result:='';
    if OneVal=0 then exit;
    if ((OneVal mod 100)<20) and ((OneVal mod 100)>10)
     then result:=Cath000(OneVal div 100)+Cath_11(OneVal mod 100)
     else result:=Cath000(OneVal div 100)+Cath_00((OneVal mod 100) div 10)+Cath__0(OneVal mod 10,(CathNum=2));
  end;

  function GetWord(OneVal,CathNum:Integer;CurrWord:boolean):string;
  var OneDigit:0..19;
  begin
    result:='';
    if ((OneVal mod 100)<20) and ((OneVal mod 100)>10)
     then OneDigit:=OneVal mod 100
     else OneDigit:=OneVal mod 10;
    if ((CathNum=1) and (not CurrWord)) then exit;
    if ((OneVal=0) and (CathNum<>1)) then exit;
    case CathNum of
      1:case OneDigit of
          0,5..9,11..19:result:=' ';
          1:result:=' ';
          2..4:result:=' ';
        end;
      2:case OneDigit of
          0,5..9,11..19:result:=' ';
          1:result:=' ';
          2..4:result:=' ';
        end;
      3:case OneDigit of
          0,5..9,11..19:result:=' ';
          1:result:=' ';
          2..4:result:=' ';
        end;
      4:case OneDigit of
          0,5..9,11..19:result:=' ';
          1:result:=' ';
          2..4:result:=' ';
        end;
      5:case OneDigit of
          0,5..9,11..19:result:=' ';
          1:result:=' ';
          2..4:result:=' ';
        end;
    end;

  end;

var
  CathNum:1..5;
  OneVal:0..999;
//  tmpstr:string;

begin
  result:='';
  if CurrValue<0 then
  begin
    raise Exception.Create(' !');
    Exit;
  end;
  if CurrValue=0 then exit;
  if ((CurrValue<1.0) and (not IfKopeck)) then exit;
  for CathNum:=5 downto 1 do
  begin
    OneVal:=GetOneVal(CurrValue,CathNum);
    result:=result+OneCathegory(OneVal,CathNum)+GetWord(OneVal,CathNum,CurrWord);
  end;
  result:=trim(result);
  if ((CurrValue<1.0) and CurrWord and IfKopeck)
   then result:=' '+result;
  if result<>'' then
     result[1]:=AnsiUpperCase(Copy(result,1,1))[1];
{    begin
     tmpstr:=AnsiUpperCase(Copy(result,1,1));
     result[1]:=tmpstr[1];
    end; }
  if (CurrWord and IfKopeck)
      then Result:=Result+GetKopeck(CurrValue);
end;

function DollarString(CurrValue:Currency):string;
begin
  result:=NumToText(CurrValue,true,true);
  result:=ReplaceStr(result,'',' ');
  result:=ReplaceStr(result,'',' ');
  result:=ReplaceStr(result,'',' ');
  result:=ReplaceStr(result,'','');
  result:=ReplaceStr(result,'','');
  result:=ReplaceStr(result,'','');
end;


end.
