unit fImpRun;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Mask, ToolEdit, Db, DBTables, RxLookup;

type
  TfrmImportRun = class(TForm)
    FilenameEdit1: TFilenameEdit;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    dsImports: TDataSource;
    RxDBLookupCombo1: TRxDBLookupCombo;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RxDBLookupCombo1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmImportRun: TfrmImportRun;

implementation

{$R *.DFM}

uses Common, QueryEx, LayoutEx, dmdURep, ImportActScrSite;

procedure TfrmImportRun.FormCreate(Sender: TObject);
begin
  ReQueryOne(dmURep.qImports);
  RxDBLookupCombo1.Value := dmURep.qImportsId.AsString;

  //controls layout
  FitControlWidthToParent(RxDBLookupCombo1);
  FitControlWidthToParent(FilenameEdit1);
end;

procedure TfrmImportRun.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmImportRun.RxDBLookupCombo1Change(Sender: TObject);
begin
  FilenameEdit1.FileName := dmURep.qImportsFileTemplate.Value;
end;

procedure TfrmImportRun.BitBtn1Click(Sender: TObject);
begin
  RunImportScript(StrToInt(RxDBLookupCombo1.Value), FilenameEdit1.FileName);
end;

end.
