unit fPasswrd;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Dialogs;

type
  TPasswordDlg = class(TForm)
    Label1: TLabel;
    Password: TEdit;
    BitBtnOK: TBitBtn;
    Label2: TLabel;
    Password2: TEdit;
    Label3: TLabel;
    Image3: TImage;
    Image1: TImage;
    BitBtnCancel: TBitBtn;
    OldPassw: TEdit;
    Image2: TImage;
    Label4: TLabel;
    procedure BitBtnOKClick(Sender: TObject);
  private
    { Private declarations }
    FOldPassword: Boolean;
    procedure SetOldPassword(OldPassword: Boolean);
  public
    { Public declarations }
    property OldPassword : Boolean
      read FOldPassword write SetOldPassword;
  end;


implementation

{$R *.DFM}

procedure TPasswordDlg.SetOldPassword(OldPassword: Boolean);
begin
  FOldPassword := OldPassword;
  OldPassw.Text := '';
  if FOldPassword then
  begin
     OldPassw.Enabled := True;
     OldPassw.Color := clWindow;
  end
  else
  begin
     OldPassw.Enabled := False;
     OldPassw.Color := clInactiveBorder;
  end;
end;

procedure TPasswordDlg.BitBtnOKClick(Sender: TObject);
begin
  if Length(Password.Text)=0 then
  begin
  MessageDlg(' !' ,mtWarning, [mbCancel], 0);
  ActiveControl := Password;
  ModalResult := mrNone;
  end;

  if Password.Text<>Password2.Text then
  begin
  MessageDlg('    !' ,mtWarning, [mbCancel], 0);
  ActiveControl := Password2;
  ModalResult := mrNone;
  end;
end;

end.

