unit fURepBLOB1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, DB, DBCtrls, ExtCtrls;

type
  TfrmURepBLOBtxt = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    CheckBox1: TCheckBox;
    DBRichEdit1: TDBRichEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
    FFieldName: string;
    FDataSource: TDataSource;
  public
    { Public declarations }
    constructor CreateFrm(AOwner: TComponent; aFieldName: string; aDataSource: TDataSource);
  end;

function URepShowFrmBLOBtxt(AOwner: TComponent; aFieldName: string; aDataSource: TDataSource) : TfrmURepBLOBtxt;

implementation

{$R *.DFM}

function URepShowFrmBLOBtxt(AOwner: TComponent; aFieldName: string; aDataSource: TDataSource) : TfrmURepBLOBtxt;
var
  i : integer;
  frmURepBLOBtxt: TfrmURepBLOBtxt;
begin
  result := nil;
  for i:=0 to (Application.MainForm.MDIChildCount-1) do
  if (Application.MainForm.MDIChildren[i] is TfrmURepBLOBtxt) then
    begin
    frmURepBLOBtxt := Application.MainForm.MDIChildren[i] as TfrmURepBLOBtxt;
    if (frmURepBLOBtxt.Owner=AOwner) and (frmURepBLOBtxt.FFieldName=aFieldName) and
       (frmURepBLOBtxt.FDataSource=aDataSource) then
      result:=frmURepBLOBtxt;
    break;
    end;
  if result = nil then
    result := TfrmURepBLOBtxt.CreateFrm(AOwner, aFieldName, aDataSource);
  result.Show;
end;


constructor TfrmURepBLOBtxt.CreateFrm(AOwner: TComponent; aFieldName: string; aDataSource: TDataSource);
begin
  FFieldName := aFieldName;
  FDataSource := aDataSource;
  inherited Create(AOwner);
  Caption := Caption + FFieldName;
  DBRichEdit1.DataSource := FDataSource;
  DBRichEdit1.DataField := FFieldName;
  //DBRichEdit1.LoadMemo;
end;

procedure TfrmURepBLOBtxt.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepBLOBtxt.CheckBox1Click(Sender: TObject);
begin
  DBRichEdit1.DataField := '';
  DBRichEdit1.DataSource := nil;
  DBRichEdit1.PlainText := not DBRichEdit1.PlainText;
  DBRichEdit1.DataSource := FDataSource;
  DBRichEdit1.DataField := FFieldName;
  CheckBox1.Checked := not DBRichEdit1.PlainText;
  //DBRichEdit1.LoadMemo;
end;

end.
