unit fURepFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, Grids, DBGrids, RXDBCtrl, ExtCtrls, Placemnt,
  Db, DBTables, RxDBComb, RxLookup, Buttons, ActnList, ComCtrls, ToolWin,
  UpdQuery, ScrlQuery, DBUtils;

type
  TfrmURepForm = class(TForm)
    Panel22: TPanel;
    LabelNN: TLabel;
    DBEditNum: TDBEdit;
    FormStorage1: TFormStorage;
    qForm: TQuery;
    qFormId: TAutoIncField;
    qFormNumm: TIntegerField;
    qFormName: TStringField;
    qFrm2Qry: TUpdQuery;
    qFrm2QryId: TAutoIncField;
    qFrm2QryIdForm: TIntegerField;
    qFrm2QryNumm: TIntegerField;
    qFrm2QryIdQuery: TIntegerField;
    DBEditName: TDBEdit;
    Label5: TLabel;
    Label6: TLabel;
    qFormIdDestination: TIntegerField;
    qFormIdTypExec: TIntegerField;
    dsForm: TDataSource;
    dsFrm2Qry: TDataSource;
    Label7: TLabel;
    qDestination: TQuery;
    qTypExec: TQuery;
    DBLookupCombo1: TDBLookupComboBox;
    DBLookupCombo2: TDBLookupComboBox;
    qFrm2QryQueryShortName: TStringField;
    ActionList1: TActionList;
    ActionExec: TAction;
    ActionTblBro: TAction;
    ActionEdtSQL: TAction;
    qFormDescription: TStringField;
    DBEditDescr: TDBEdit;
    Label8: TLabel;
    ActionEdtRepFrm: TAction;
    Panel1: TPanel;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    Panel2: TPanel;
    Label2: TLabel;
    LookupComboForm: TRxDBLookupCombo;
    DBNavigator2: TDBNavigator;
    PageControl1: TPageControl;
    TabSheetQuery: TTabSheet;
    Panel3: TPanel;
    Panel4: TPanel;
    RxDBGrid1: TRxDBGrid;
    TabSheetGrpFrm: TTabSheet;
    qSelFrm: TUpdQuery;
    dsSelFrm: TDataSource;
    qSelFrmId: TAutoIncField;
    qSelFrmNumm: TIntegerField;
    qSelFrmName: TStringField;
    ActionClearRepFrm: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    DBNavigator3: TDBNavigator;
    Panel5: TPanel;
    RxDBGrid2: TRxDBGrid;
    qGrpFrm: TUpdQuery;
    dsGrpFrm: TDataSource;
    qGrpFrmId: TAutoIncField;
    qGrpFrmGrpName: TStringField;
    qFormDestination: TStringField;
    qFormTypExec: TStringField;
    DBEditID: TDBEdit;
    LabelID: TLabel;
    dsDestination: TDataSource;
    dsTypExec: TDataSource;
    qDestinationIval: TIntegerField;
    qDestinationItem: TStringField;
    qTypExecIval: TIntegerField;
    qTypExecItem: TStringField;
    qFrm2QryIdRemoteData: TIntegerField;
    qFrm2QryName: TStringField;
    qFrm2QryIsMaster: TIntegerField;
    CoolBar2: TCoolBar;
    ToolBar2: TToolBar;
    DBNavigator1: TDBNavigator;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    CoolBar3: TCoolBar;
    ToolBar3: TToolBar;
    DBNavigator4: TDBNavigator;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ActionEditGroup: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure qFrm2QryNewRecord(DataSet: TDataSet);
    procedure qFormAfterPost(DataSet: TDataSet);
    procedure qFormBeforePost(DataSet: TDataSet);
    procedure qFormAfterDelete(DataSet: TDataSet);
    procedure qFrm2QryAfterPost(DataSet: TDataSet);
    procedure qFormNewRecord(DataSet: TDataSet);
    procedure qFrm2QryAfterDelete(DataSet: TDataSet);
    procedure ActionExecExecute(Sender: TObject);
    procedure ActionTblBroExecute(Sender: TObject);
    procedure ActionEdtSQLExecute(Sender: TObject);
    procedure ActionEdtRepFrmExecute(Sender: TObject);
    procedure DBNavigator2Click(Sender: TObject; Button: TNavigateBtn);
    procedure LookupComboFormChange(Sender: TObject);
    procedure qFormBeforeOpen(DataSet: TDataSet);
    procedure qFrm2QryBeforeOpen(DataSet: TDataSet);
    procedure ActionClearRepFrmExecute(Sender: TObject);
    procedure qGrpFrmBeforeOpen(DataSet: TDataSet);
    procedure DBNavigator3BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure dsFormDataChange(Sender: TObject; Field: TField);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure RxDBGrid1ShowEditor(Sender: TObject; Field: TField;
      var AllowEdit: Boolean);
    procedure RxDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure RxDBGrid1CellClick(Column: TColumn);
    procedure RxDBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure ActionEditGroupExecute(Sender: TObject);
  private
    { Private declarations }
    WasInsertForm : Boolean;
    FNameChanged: Boolean;
  public
    { Public declarations }
    procedure FindForm(IdForm, IdQuery, IdRemoteData: integer);
  end;


implementation

{$R *.DFM}

uses dmdURep, Common, CommonVV, AskMe, GridEx, QueryEx, ConstEx, LayoutEx,
     fURepFunc1, URepTypes, fURepQryBro, fURepQry, fURepQryAdd, fURepRemt,
     fURepGrp, URepConstants;


procedure TfrmURepForm.FormCreate(Sender: TObject);
begin
  FNameChanged := False;
  ReQueryAll(Self);
  LookupComboForm.Value := qSelFrmId.asString;
  PageControl1.ActivePage := TabSheetQuery;

  //controls layout
  FitControlLeftToParent(DBNavigator2);
  FitControlWidthToRControl(LookupComboForm, DBNavigator2);

  FitControlLeftToParent(DBEditNum);
  FitControlLeftToRControl(LabelNN, DBEditNum);
  FitControlWidthToRControl(DBEditName, LabelNN);

  FitControlLeftToParent(DBEditID);
  FitControlLeftToRControl(LabelID, DBEditID);
  FitControlWidthToRControl(DBEditDescr, LabelNN);

end;

procedure TfrmURepForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepForm.FindForm(IdForm, IdQuery, IdRemoteData: integer);
begin
  if IdForm<>0 then
    begin
    qSelFrm.Locate(fldId, IdForm, []);
    LookupComboForm.Value := qSelFrmId.asString;
    end;
  if IdQuery<>0 then
    begin
    PageControl1.ActivePage := TabSheetQuery;
    qFrm2Qry.Locate(fldIdQuery, IdQuery, []);
    end;
  if IdRemoteData<>0 then
    begin
    PageControl1.ActivePage := TabSheetQuery;
    qFrm2Qry.Locate(fldIdRemoteData, IdRemoteData, []);
    end;
end;

procedure TfrmURepForm.LookupComboFormChange(Sender: TObject);
begin
  ReQueryOne(qForm);
  ReQueryOne(qFrm2Qry);
  ReQueryOne(qGrpFrm);
end;

procedure TfrmURepForm.qFormBeforeOpen(DataSet: TDataSet);
begin
  qForm.ParamByName(fldId).asInteger := qSelFrmId.Value;
end;

procedure TfrmURepForm.qFrm2QryBeforeOpen(DataSet: TDataSet);
begin
  qFrm2Qry.ParamByName(fldId).asInteger := qSelFrmId.Value;
end;

procedure TfrmURepForm.DBNavigator2Click(Sender: TObject;
  Button: TNavigateBtn);
begin
  LookupComboForm.Value := qSelFrmId.asString;
end;

procedure TfrmURepForm.qGrpFrmBeforeOpen(DataSet: TDataSet);
begin
  qGrpFrm.ParamByName(fldId).asInteger := qSelFrmId.Value;
end;

procedure TfrmURepForm.qFrm2QryNewRecord(DataSet: TDataSet);
var
  frmURepAddQuery: TfrmURepAddQuery;
begin
  qFrm2QryIdForm.Value := qFormId.Value;
  qFrm2QryIsMaster.Value := 0;
  qFrm2QryNumm.Value := URepFrm2QryNumm(qFrm2QryIdForm.Value);
  qFrm2QryQueryShortName.Value := 'Query'+IntToStr(qFrm2QryNumm.Value);
  frmURepAddQuery:= TfrmURepAddQuery.Create(Self);
  If frmURepAddQuery.ShowModal <> mrOK Then Abort;
  frmURepAddQuery.GetQuery(qFrm2Qry);
  frmURepAddQuery.Release;
end;

procedure TfrmURepForm.qFormBeforePost(DataSet: TDataSet);
begin
  WasInsertForm:=(qForm.State=dsInsert);
end;

procedure TfrmURepForm.qFormAfterPost(DataSet: TDataSet);
var
  maxId : integer;
begin
  ReQueryOne(qSelFrm); //!
  if WasInsertForm then
    begin
    maxId :=DLookup('select max(Id) from URepForm');
    qSelFrm.Locate('Id', maxId, []);
    end;
  LookupComboForm.Value:= qSelFrmId.AsString;//!
  if WasInsertForm or FNameChanged then
    GoMessage(WM_UREPTBLCHANGE);
  FNameChanged := False;
end;

procedure TfrmURepForm.qFormAfterDelete(DataSet: TDataSet);
begin
  if not qSelFrm.BOF then
    qSelFrm.Prior
  else
    if not qSelFrm.EOF then
      qSelFrm.Next
    else
      ReQueryOne(qSelFrm);
  LookupComboForm.Value := qSelFrmId.AsString;
  GoMessage(WM_UREPTBLCHANGE);
end;

procedure TfrmURepForm.qFrm2QryAfterPost(DataSet: TDataSet);
begin
  GoMessage(WM_UREPTBLCHANGE);
end;

procedure TfrmURepForm.qFormNewRecord(DataSet: TDataSet);
var
  params : TParams;
begin
  qFormIdDestination.Value := 0;
  qFormIdTypExec.Value := 1;
  params := TParams.Create;
  try
    params.CreateParam(ftInteger, prmPrefix+fldNumm, ptOutput);
    ExecSP('spURepFormNumm', params);
    qFormNumm.Value := params.ParamValues[prmPrefix+fldNumm];
  finally
    params.Free;
  end;
end;

procedure TfrmURepForm.qFrm2QryAfterDelete(DataSet: TDataSet);
begin
  GoMessage(WM_UREPTBLCHANGE);
end;

procedure TfrmURepForm.ActionExecExecute(Sender: TObject);
begin
  URepActionReport(qFormId.Value, qFormName.Value,
                   qFormIdDestination.Value, qFormIdTypExec.Value);
end;

procedure TfrmURepForm.ActionTblBroExecute(Sender: TObject);
begin
  URepExtFormAction(qFormId.AsInteger, qFormName.AsString, nil,
                    factViewAsTbl, '', 0, Ord(ttForm));
end;

procedure TfrmURepForm.ActionEdtSQLExecute(Sender: TObject);
var
  frmURepQuery : TfrmURepQuery;
  frmUrepRemoteData: TfrmUrepRemoteData;
begin
  if qFrm2Qry.RecordCount=0 then Exit;
  If qFrm2QryIdQuery.Value>0 then
  begin
    frmURepQuery := GetOneFormExt(TfrmURepQuery, URepGetMainForm) as TfrmURepQuery;
    frmURepQuery.FindQuery(qFrm2QryIdQuery.Value);
  end else
  If qFrm2QryIdRemoteData.Value>0 then
  begin
    frmURepRemoteData := GetOneFormExt(TfrmURepRemoteData, URepGetMainForm) as TfrmURepRemoteData;
    frmURepRemoteData.FindRemote(qFrm2QryIdRemoteData.Value);
  end
end;

procedure TfrmURepForm.ActionEdtRepFrmExecute(Sender: TObject);
begin
  URepEditRepForm(qFormId.AsInteger, qFormName.AsString);
end;


procedure TfrmURepForm.ActionClearRepFrmExecute(Sender: TObject);
begin
  if Confirmation('  ?') then
    DoSQL('Update URepForm set Report=NULL where Id='+qFormId.AsString);
end;

procedure TfrmURepForm.DBNavigator3BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbRefresh then
     begin
     ReQueryOne(qForm);
     //qForm.Close;
     //qForm.Open;
     Abort;
     end;
end;

procedure TfrmURepForm.dsFormDataChange(Sender: TObject; Field: TField);
begin
  if Field=nil then Exit;
  if (Field=qFormName) or
     (Field=qFormNumm) or
     (Field=qFormIdDestination) or
     (Field=qFormIdTypExec) then
    FNameChanged := True;
end;

procedure TfrmURepForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  ConfirmDataSetCancel(qForm);
  ConfirmDataSetCancel(qFrm2Qry);
end;

procedure TfrmURepForm.RxDBGrid1ShowEditor(Sender: TObject; Field: TField;
  var AllowEdit: Boolean);
begin
  if (Field=qFrm2QryIdQuery) or
     (Field=qFrm2QryIsMaster) then
    AllowEdit:= False;
end;

procedure TfrmURepForm.RxDBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
 aBitmap: TBitmap;
 TxtRect: TRect;
 iIndex: integer;
 sText: string;
begin
  if (Column.Field=qFrm2QryIdQuery) and
     (not(qFrm2QryIdQuery.IsNull and qFrm2QryIdRemoteData.IsNull)) then
    begin
    If qFrm2QryIdQuery.Value=0 then
    begin
      iIndex := 40;
      sText := 'RemoteData';
    end else
    begin
      iIndex := 3;
      sText := 'Query';
    end;

    aBitmap := TBitmap.Create;
    dmURep.imgLstURep.GetBitmap(iIndex, aBitmap);
    RxDBGrid1.Canvas.FillRect(Rect);
    RxDBGrid1.Canvas.Draw(Rect.Left+5,
                          (Rect.Top+Rect.Bottom-aBitmap.Height) div 2,
                          aBitmap);

    TxtRect := Rect;
    TxtRect.Left := Rect.Left+5+aBitmap.Width+5;
    RxDBGrid1.Canvas.TextRect(TxtRect, Rect.Left+5+aBitmap.Width+10,
                             Rect.Top, //(Rect.Top+ Rect.Bottom) div 2,
                             sText);
    aBitmap.Free;
    end
  else if (Column.Field=qFrm2QryIsMaster) then
  begin
    aBitmap := GetBoolImage(qFrm2QryIsMaster.Value>0);
    RxDBGrid1.Canvas.FillRect(Rect);
    RxDBGrid1.Canvas.Draw((Rect.Left+Rect.Right-aBitmap.Width) div 2,(Rect.Top+Rect.Bottom-aBitmap.Height) div 2, aBitmap);
  end
  else
    BoolRXDBGridDrawColumnCell(Rect, DataCol, Column, State);
end;

var
  LastClicTime: TDateTime;
  LastClicFieldName: string;
  LastClicRecNo: integer;

procedure TfrmURepForm.RxDBGrid1CellClick(Column: TColumn);
var
  IsNotModified:boolean; SavIndex: integer;
  function DataSet:TDataSet; begin result:=RxDBGrid1.DataSource.DataSet end;
begin
  if Column<>nil then
    begin
    if (LastClicTime=0) or
       ((Time - LastClicTime)>EncodeTime(0, 0, 0, 500)) or
       (LastClicFieldName <> Column.FieldName) or
       (LastClicRecNo <> DataSet.RecNo) Then
      begin
      LastClicTime := Time;
      LastClicFieldName := Column.FieldName;
      LastClicRecNo := DataSet.RecNo;
      Exit;
      end;
    LastClicTime := Time;
    LastClicFieldName := Column.FieldName;
    LastClicRecNo := DataSet.RecNo;
    end;
  if not (RxDBGrid1.SelectedField=qFrm2QryIsMaster) then Exit;
  IsNotModified:=not DataSet.Modified;
  if IsNotModified then DataSet.Edit;
  If qFrm2QryIsMaster.Value>0 then qFrm2QryIsMaster.Value:=0
  Else qFrm2QryIsMaster.Value:=1;
  if IsNotModified and (DataSet.State<>dsInsert) then
    try
      DataSet.Post;
    finally
      SavIndex:=RxDBGrid1.SelectedIndex;
      RxDBGrid1.SelectedIndex:=-1;
      if RxDBGrid1.SelectedIndex=SavIndex then
        begin
        RxDBGrid1.SelectedIndex:= 0;
        if RxDBGrid1.SelectedIndex=SavIndex then
          RxDBGrid1.SelectedIndex:=RxDBGrid1.Columns.Count-1;
        end;
      RxDBGrid1.SelectedIndex:=SavIndex;
      RxDBGrid1.Refresh;
      RxDBGrid1.Repaint;
    end;
end;

procedure TfrmURepForm.RxDBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if (RxDBGrid1.SelectedField=qFrm2QryIsMaster) and
      (Key=#32) then
    RxDBGrid1CellClick(nil);
end;

procedure TfrmURepForm.ActionEditGroupExecute(Sender: TObject);
var
  frmURepGrpFrm: TfrmURepGrpFrm;
begin
  frmURepGrpFrm := GetOneFormExt(TfrmURepGrpFrm, URepGetMainForm) as TfrmURepGrpFrm;
  frmURepGrpFrm.FindGrpFrm(qGrpFrmId.Value, qSelFrmId.Value, 0);
end;

end.
