unit fURepFunc0;

interface

// internal functions only
procedure URepLogAction(iAction, IdRec: integer; Name: string);

implementation

uses  Db, CommonVV, URepConstants;

procedure URepLogAction(iAction, IdRec: integer; Name: string);
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftInteger, prmPrefix+'IdAction', ptInput);
   params.CreateParam(ftInteger, prmPrefix+'ValueId', ptInput);
   params.CreateParam(ftString,  prmPrefix+fldName, ptInput);

   params.ParamValues[prmPrefix+'IdAction'] := iAction;
   params.ParamValues[prmPrefix+'ValueId'] := IdRec;
   params.ParamValues[prmPrefix+fldName] := Name;

   ExecSP('spURepLogAction', params);
 finally
   params.Free;
 end;
end;

end.
