unit unRTFfunc;

interface

uses graphics, comctrls;

procedure SelTexBold(RichEdit: TRichEdit; Text: string);
procedure SelTexItalic(RichEdit: TRichEdit; Text: string);
procedure SelTexGreen(RichEdit: TRichEdit; Text: string);
procedure AddNewLine(RichEdit: TRichEdit );

implementation

//----------------------------------------------------------
//   TRichEdit
//----------------------------------------------------------
procedure SelTexBold(RichEdit: TRichEdit; Text: string);
begin
  RichEdit.SelAttributes.Style := [fsBold];
  RichEdit.SelText := Text;
  RichEdit.SelAttributes.Style := [];
end;

procedure SelTexItalic(RichEdit: TRichEdit; Text: string);
begin
  RichEdit.SelAttributes.Style := [fsItalic];
  RichEdit.SelText := Text;
  RichEdit.SelAttributes.Style := [];
end;

procedure SelTexGreen(RichEdit: TRichEdit; Text: string);
var
  Color: TColor;
begin
  Color := RichEdit.SelAttributes.Color;
  RichEdit.SelAttributes.Color := clGreen;
  RichEdit.SelText := Text;
  RichEdit.SelAttributes.Color := Color;
  RichEdit.SelText := ' ';
end;

procedure AddNewLine(RichEdit: TRichEdit );
begin
  RichEdit.Lines.Add('');
end;

end.
