program URepGenApp;

uses
  Forms,
  VCLUtils,
  frURepGenAppMDIMain in 'frURepGenAppMDIMain.pas' {frmURepGenAppMDImain},
  Common in '..\CommUnit\Common.pas',
  dmdURep in '..\CommUnit\dmdURep.pas' {dmURep: TDataModule},
  frAboutMe in 'frAboutMe.pas' {dlgAbout},
  URepGenApp_TLB in 'URepGenApp_TLB.pas',
  Impl_Application in 'Impl_Application.pas' {Application: CoClass},
  SendMsg in 'SendMsg.pas' {fmSendMessage},
  fURepMain in '..\CommUnit\fURepMain.pas' {frmURepMain},
  fURepFrm in '..\CommUnit\fURepFrm.pas' {frmURepForm},
  fURepQry in '..\CommUnit\fURepQry.pas' {frmURepQuery},
  fURepParam in '..\CommUnit\fURepParam.pas' {frmURepParam},
  fURepScr in '..\CommUnit\fURepScr.pas' {frmURepScript},
  fURepBLOB2 in '..\CommUnit\fURepBLOB2.pas' {frmURepBLOBimage},
  fURepBLOB1 in '..\CommUnit\fURepBLOB1.pas' {frmURepBLOBtxt},
  fURepFunc1 in '..\CommUnit\fURepFunc1.pas',
  fURepRights in '..\CommUnit\fURepRights.pas' {frmURepRights},
  fURepDelDep in '..\CommUnit\fURepDelDep.pas' {frmURepDelDepends},
  fURepQryBro in '..\CommUnit\fURepQryBro.pas' {frmURepQueryBro},
  Impl_URepQuerys in '..\CommUnit\Impl_URepQuerys.pas',
  fURepGrp in '..\CommUnit\fURepGrp.pas' {frmURepGrpFrm},
  fLoginDB in '..\CommUnit\fLoginDB.pas' {frmLoginDB},
  fImport in '..\CommUnit\fImport.pas' {frmImportSet},
  ImportActScrSite in '..\CommUnit\ImportActScrSite.pas',
  Impl_URepMain in '..\CommUnit\Impl_URepMain.pas',
  Impl_URepImports in '..\CommUnit\Impl_URepImports.pas',
  fUrepActScpSite in '..\CommUnit\fUrepActScpSite.pas',
  fURepRemt in '..\CommUnit\fURepRemt.pas' {frmUrepRemoteData},
  Impl_URepQuery in '..\CommUnit\Impl_URepQuery.pas',
  Impl_URepFields in '..\CommUnit\Impl_URepFields.pas',
  Impl_URepParams in '..\CommUnit\Impl_URepParams.pas',
  Impl_URepObjectFactory in '..\CommUnit\Impl_URepObjectFactory.pas',
  URepConstants in '..\CommUnit\URepConstants.pas',
  Impl_URepCollection in '..\CommUnit\Impl_URepCollection.pas',
  fURepBrowser in '..\CommUnit\fURepBrowser.pas' {frmURepBrowser},
  unAxBowser in '..\CommUnit\unAxBowser.pas',
  fURepQryAdd in '..\CommUnit\fURepQryAdd.pas' {frmURepAddQuery},
  fURepReferences in '..\CommUnit\fURepReferences.pas' {frmURepReferences},
  URepTypeLibs in '..\CommUnit\URepTypeLibs.pas',
  Impl_URepFunction in '..\CommUnit\Impl_URepFunction.pas',
  Askme in '..\CommUnit\AskMe.pas' {frmAskMe},
  URepTypes in '..\CommUnit\URepTypes.pas',
  ExceptEx in '..\CommUnit\ExceptEx.pas',
  fImpRun in '..\CommUnit\fImpRun.pas' {frmImportRun},
  QueryEx in '..\CommUnit\QueryEx.pas',
  Slot in '..\CommUnit\Slot.pas' {fmSlot},
  LayoutEx in '..\CommUnit\LayoutEx.pas',
  UserInfo in '..\CommUnit\UserInfo.pas',
  unAddQRFnc in '..\CommUnit\unAddQRFnc.pas',
  dlgOrd in '..\CommUnit\dlgOrd.pas' {dlgOrder},
  Impl_URepQryPrm in '..\CommUnit\Impl_URepQryPrm.pas',
  CommonVV in '..\CommUnit\CommonVV.pas',
  fURepFunc2 in '..\CommUnit\fURepFunc2.pas',
  fURepFunc0 in '..\CommUnit\fURepFunc0.pas',
  fURepLogins in '..\CommUnit\fURepLogins.pas' {frmURepLogins};

{$R *.TLB}

{$R *.RES}

begin
  Forms.Application.Initialize;
  Forms.Application.Title := '  URep';
  //if ActivatePrevInstance(TfrmURepGenAppMDImain.ClassName, '') then Exit;
  Forms.Application.CreateForm(TdmURep, dmURep);
  Forms.Application.CreateForm(TfrmURepGenAppMDImain, frmURepGenAppMDImain);
  If Forms.Application.Tag=-1 then
  begin
    dmURep.Free;
    frmURepGenAppMDImain.Free;
    Exit;
  end;
  Forms.Application.Run;
end.
