unit JustOne;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, Global;

type
  TJustOne = class(TComponent)
  private
   MyMutex: HWND;
   MutexCreated: boolean;
  public
   constructor Create(AOwner: TComponent); override;
   destructor Destroy; override;
  end;

implementation

 constructor TJustOne.Create(AOwner: TComponent);
 var
  MN: String;
 begin
  inherited Create(AOwner);
  MutexCreated:=FALSE;
  MN:=ExtractFileName(Application.ExeName);
  MyMutex:=0;
  MyMutex:=CreateMutex(NIL,FALSE,PChar(MN));
  if (GetLastError = ERROR_ALREADY_EXISTS) OR
     (MyMutex = 0) then
  begin
   WarningMsg('"'+Application.Title+'"'#10#13+' !');
   Halt(1);
   Exit;
  end;
  MutexCreated:=TRUE;
 end;

 destructor TJustOne.Destroy;
 begin
  if MutexCreated then
   CloseHandle(MyMutex);
  inherited Destroy;
 end;

end.
