unit OneInst;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, Global;

type
  TOneInst = class(TComponent)
  private
   MyMutex: HWND;
   MutexCreated: boolean;
   hPrevInst:hWnd;
  public
   constructor Create(AOwner: TComponent); override;
   destructor Destroy; override;
  end;

implementation

 constructor TOneInst.Create(AOwner: TComponent);
 var
  MN: String;
 begin
  inherited Create(AOwner);
  MutexCreated:=FALSE;
  MN:=ExtractFileName(Application.ExeName);
  MyMutex:=0;
  MyMutex:=CreateMutex(NIL,FALSE,PChar(MN));
  if (GetLastError = ERROR_ALREADY_EXISTS) OR
     (MyMutex = 0) then
  begin
   {hPrevInst:=FindWindow(nil,PChar(Application.Title));
   if hPrevInst<>0 then
     begin
  	    if IsIconic(hPrevInst)
           then ShowWindow(hPrevInst, SW_SHOWNORMAL)
  	        else SetForegroundWindow(hPrevInst);
         ShowWindow(hPrevInst,SW_RESTORE);
         BringWindowToTop(hPrevInst);
         SetForegroundWindow(hPrevInst);
     end
    else}
   WarningMsg('"'+Application.Title+'"'#10#13+' !');
   Halt(0);
   Exit;
  end;
  MutexCreated:=TRUE;
 end;

 destructor TOneInst.Destroy;
 begin
  if MutexCreated then
   CloseHandle(MyMutex);
  inherited Destroy;
 end;

end.
