unit URepCmndLine;

interface

procedure CmndLineRunScriptOrImport;

const
  cnstRunScript  = 'RunScript';
  cnstRunImport  = 'RunImport';
  cnstImportFile = 'ImportFile';

implementation

uses Sysutils, Forms, CmdPrms, dmdURep,
     fURepFunc2, ImportActScrSite;

procedure CmndLineRunScriptOrImport;
var iValue: integer;  sImportFile: string;
begin
  if IsCmdValueExist(cnstRunScript) then
    begin
      iValue := StrToIntDef(GetCmdParam(cnstRunScript),0);
      If iValue>0 then
      begin
        URepRunScript(iValue);
        Forms.Application.Tag:=-1;
      end;
    end
  else if IsCmdValueExist(cnstRunImport) then
    begin
      sImportFile := '';
      if IsCmdValueExist(cnstImportFile) Then
        sImportFile := GetCmdParam(cnstImportFile);
      iValue := StrToIntDef(GetCmdParam(cnstRunImport),0);
      If iValue>0 then
      begin
        RunImportScript(iValue, sImportFile);
        Forms.Application.Tag:=-1;
      end;
    end;
end;

end.
