unit fURepQryAdd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, Grids, DBGrids, RXDBCtrl, Db,
  DBTables, DBCtrls;

type
  TfrmURepAddQuery = class(TForm)
    Panel1: TPanel;
    BitBtnOK: TBitBtn;
    BitBtnCancel: TBitBtn;
    PageControl1: TPageControl;
    TabSheetQuery: TTabSheet;
    TabSheetRemoteData: TTabSheet;
    RxDBGrid1: TRxDBGrid;
    qQuery: TQuery;
    qRemoteData: TQuery;
    qQueryId: TAutoIncField;
    qQueryName: TStringField;
    qQueryDescription: TStringField;
    qRemoteDataId: TAutoIncField;
    qRemoteDataName: TStringField;
    qRemoteDataDescription: TStringField;
    qQueryNumm: TIntegerField;
    qRemoteDataNumm: TIntegerField;
    dsQuery: TDataSource;
    dsRemoteData: TDataSource;
    Panel2: TPanel;
    DBNavigator1: TDBNavigator;
    Panel3: TPanel;
    DBNavigator2: TDBNavigator;
    RxDBGrid2: TRxDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure qQueryBeforeOpen(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FindQuery(IdQuery, IdRemoteData: Integer);
    procedure GetQuery(DataSet: TDataSet);
  end;


implementation

{$R *.DFM}

uses dmdURep, URepConstants, QueryEx, Common, CommonVV;

procedure TfrmURepAddQuery.FormCreate(Sender: TObject);
begin
  ReQueryAll(Self);
  PageControl1.ActivePage := TabSheetQuery;
end;


procedure TfrmURepAddQuery.FindQuery(IdQuery, IdRemoteData: Integer);
begin
  If IdQuery>0 then
  begin
    PageControl1.ActivePage := TabSheetQuery;
    qQuery.Locate('Id', IdQuery, []);
  end;
  If IdRemoteData>0 then
  begin
    PageControl1.ActivePage := TabSheetRemoteData;
    qRemoteData.Locate('Id', IdRemoteData, []);
  end;
end;


procedure TfrmURepAddQuery.GetQuery(DataSet: TDataSet);
begin
  if PageControl1.ActivePage = TabSheetQuery then
  begin
    DataSet.FieldByName(fldIdQuery).AsInteger := qQueryId.Value;
    DataSet.FieldByName(fldName).asString := qQueryName.Value;
    DataSet.FieldByName(fldIdRemoteData).Clear;
  end
  else if PageControl1.ActivePage = TabSheetRemoteData then
  begin
    DataSet.FieldByName(fldIdQuery).Clear;
    DataSet.FieldByName(fldIdRemoteData).AsInteger := qRemoteDataId.Value;
    DataSet.FieldByName(fldName).AsString := qRemoteDataName.Value;
  end;
end;


procedure TfrmURepAddQuery.qQueryBeforeOpen(DataSet: TDataSet);
begin
  setOrderBy(DataSet, cnstOrderBy+URepTreeSortOrderString[dmURep.FSortOrder]);
end;

end.
