unit frAboutMe;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ShellAPI, StrHlder, RxVerInf;

type
  TdlgAbout = class(TForm)
    OKBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    lblAut1: TLabel;
    lblMail1: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    lblVer: TLabel;
    Label3: TLabel;
    lblAut2: TLabel;
    lblMail2: TLabel;
    StrHolder1: TStrHolder;
    Label2: TLabel;
    procedure LabelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation

{$R *.DFM}

procedure TdlgAbout.LabelClick(Sender: TObject);
var
 eMail : PChar;
begin
  eMail := PChar('mailto:'+(Sender as TLabel).Caption);
  ShellExecute(Handle, 'open', eMail, nil, nil, SW_SHOW);
end;


procedure TdlgAbout.FormCreate(Sender: TObject);
var
  VersionInfo: TVersionInfo;
begin
  lblAut1.Caption := StrHolder1.Strings[0];
  lblAut2.Caption := StrHolder1.Strings[1];
  lblMail1.Caption := StrHolder1.Strings[2];
  lblMail2.Caption := StrHolder1.Strings[3];

  VersionInfo := TVersionInfo.Create(Forms.Application.ExeName);
  lblVer.Caption := ' '+VersionInfo.FileVersion;
  VersionInfo.Free;
end;

end.
